# -*- coding: utf-8 -*- #

require 'yaml'

module ApacheKeywords
  extend self
  def keywords
    ::YAML.load_file(File.join(__dir__, 'apache/keywords.yml'))
  end

  def source(&b)
    yield   '# -*- coding: utf-8 -*- #'
    yield   '# frozen_string_literal: true'
    yield   ''
    yield   '# automatically generated by `rake builtins:apache`'
    yield   'module Rouge'
    yield   '  module Lexers'
    yield   '    def Apache.keywords'
    yield   '      @keywords ||= {}.tap do |h|'
    keywords.each do |key, value|
      yield "        h[#{key.inspect}] = Set.new #{value}"
    end
    yield   '      end'
    yield   '    end'
    yield   '  end'
    yield   'end'
  end
end

namespace :builtins do
  task :apache do
    File.open('lib/rouge/lexers/apache/keywords.rb', 'w') do |f|
      ApacheKeywords.source { |line| f.puts line }
    end
  end
end
