# -*- coding: utf-8 -*- #

require 'yaml'

module MatlabBuiltins
  extend self
  def builtins
    ::YAML.load_file(File.join(__dir__, 'matlab/builtins.yml'))
  end

  def source(&b)
    yield   '# -*- coding: utf-8 -*- #'
    yield   '# frozen_string_literal: true'
    yield   ''
    yield   '# automatically generated by `rake builtins:matlab`'
    yield   'module Rouge'
    yield   '  module Lexers'
    yield   '    def Matlab.builtins'
    yield   "      @builtins ||= Set.new #{builtins}"
    yield   '    end'
    yield   '  end'
    yield   'end'
  end
end

namespace :builtins do
  task :matlab do
    File.open('lib/rouge/lexers/matlab/builtins.rb', 'w') do |f|
      MatlabBuiltins.source { |line| f.puts line }
    end
  end
end
